"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path_1 = __importDefault(require("path"));
const logger_1 = __importDefault(require("../script/logger"));
const utils_1 = require("../script/utils");
const utils_2 = require("../script/utils");
const utils_3 = require("../../utils");
/**
 * reg: https://regex101.com/r/ai3qvO/1
 */
function run(args) {
    return __awaiter(this, void 0, void 0, function* () {
        const basePath = typeof args.path !== 'undefined' ? args.path : './';
        const sourceDirPath = path_1.default.join(basePath, '_sources');
        const idPrefix = typeof args.idPrefix !== 'undefined' ? args.idPrefix : 'icon_';
        logger_1.default.info(`svg merge symbols ${basePath} ...`);
        const symbol = [];
        const iconCodes = [];
        const dirChildFiles = fs.readdirSync(sourceDirPath);
        const targetSvgFile = path_1.default.join(basePath, 'index.svg');
        const targetTsTypeFile = path_1.default.join(basePath, 'db.d.ts');
        const targetDartTypeFile = path_1.default.join(basePath, 'db.dart');
        dirChildFiles.forEach(file => {
            if (path_1.default.extname(file) == '.svg') {
                const filename = file.replace('.svg', '');
                const iconCode = [idPrefix, filename].join('');
                const svgContent = fs
                    .readFileSync(path_1.default.join(sourceDirPath, file), { encoding: 'utf8', flag: 'r' })
                    .toString();
                const svgPaths = (0, utils_3.decodeSvgPath)(svgContent);
                symbol.push(`  <symbol id="${iconCode}">\n${svgPaths.paths.join('\n')}\n  </symbol>`);
                iconCodes.push(`${filename}`);
            }
        });
        // write file
        fs.writeFileSync(targetSvgFile, `<svg xmlns="http://www.w3.org/2000/svg" style="display: none;">\n
${symbol.join('\n\n')}\n
</svg>`);
        logger_1.default.success(`Build to ${targetSvgFile}, size: ${(0, utils_2.getFilesizeInBytes)(targetSvgFile)}`);
        // ========= write typescript type file =========
        fs.writeFileSync(targetTsTypeFile, `
declare type TIconCode = ${iconCodes.map(code => `'${code}'`).join('|')};
declare enum EIconCode {
  ${iconCodes.map(code => `'${code}'='${code}'`).join(',\n  ')}
}
export {TIconCode, EIconCode}
`);
        logger_1.default.success(`Build to ${targetTsTypeFile}, size: ${(0, utils_2.getFilesizeInBytes)(targetTsTypeFile)}`);
        // ========= write dart flutter type file =========
        const varName = 'Map<EIconCode, String> iconCodeMapping';
        fs.writeFileSync(targetDartTypeFile, `
enum EIconCode {
  ${iconCodes.join(',\n  ')}
}

${varName} = {
  ${iconCodes.map(code => {
            return `EIconCode.${code}: '${code}',`;
        }).join('\n  ')}    
};


`);
        logger_1.default.success(`Build to ${targetDartTypeFile}, size: ${(0, utils_2.getFilesizeInBytes)(targetDartTypeFile)}`);
        // By OSX Notice
        (0, utils_1.bash)(`osascript -e 'display notification "${basePath} done" with title "publish done"'`);
    });
}
exports.default = run;
module.exports = run;
//# sourceMappingURL=index.js.map