"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path_1 = __importDefault(require("path"));
const equal_1 = require("bear-jsutils/equal");
const logger_1 = __importDefault(require("../script/logger"));
const svg_parser_1 = require("svg-parser");
const utils_1 = require("../script/utils");
const utils_2 = require("../../utils");
/**
 * decode iconfont.js to _sources/svgs
 * reg: https://regex101.com/r/ai3qvO/1
 * @param args
 */
function run(args) {
    return __awaiter(this, void 0, void 0, function* () {
        const basePath = typeof args.path !== 'undefined' ? args.path : './';
        const sourceDirPath = path_1.default.join(basePath, '_sources');
        const idPrefix = typeof args.idPrefix !== 'undefined' ? args.idPrefix : 'icon_';
        logger_1.default.info(`iconfont decode svgs ${basePath} ...`);
        if (!fs.existsSync(sourceDirPath)) {
            fs.mkdirSync(sourceDirPath, { recursive: true });
        }
        const iconfontJsFile = path_1.default.join(basePath, 'iconfont.js');
        const jsContent = fs
            .readFileSync(iconfontJsFile, { encoding: 'utf8', flag: 'r' })
            .toString();
        const svgReg = new RegExp(equal_1.regPattern.svg);
        const svgTags = svgReg.exec(jsContent);
        if (svgTags && svgTags.length > 0) {
            const symbolTags = svgTags[0].match(equal_1.regPattern.symbol);
            if (symbolTags && symbolTags.length > 0) {
                // const result = symbolTags[0];
                symbolTags.forEach(symbolStr => {
                    const svgString = (0, svg_parser_1.parse)(symbolStr);
                    const svgPaths = (0, utils_2.remarkDeepSVGPaths)(svgString.children);
                    const idRes = new RegExp(equal_1.regPattern.htmlAttrId).exec(symbolStr);
                    if (idRes && idRes.length > 1) {
                        const filename = `${idRes[1].replace(idPrefix, '')}.svg`;
                        logger_1.default.success(filename);
                        const targetSvgFile = path_1.default.join(sourceDirPath, filename);
                        fs.writeFileSync(targetSvgFile, `<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 1024 1024" width="200" height="200">\n${svgPaths.join('\n')}\n</svg>`);
                    }
                    else {
                        logger_1.default.error(symbolStr);
                    }
                });
            }
        }
        // By OSX Notice
        (0, utils_1.bash)(`osascript -e 'display notification "${basePath} done" with title "publish done"'`);
    });
}
exports.default = run;
module.exports = run;
//# sourceMappingURL=index.js.map