"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const path_1 = __importDefault(require("path"));
const logger_1 = __importDefault(require("../script/logger"));
const utils_1 = require("../script/utils");
const equal_1 = require("bear-jsutils/equal");
const string_1 = require("bear-jsutils/string");
function run(args) {
    return __awaiter(this, void 0, void 0, function* () {
        const basePath = typeof args.path !== 'undefined' ? args.path : './';
        const sourceDirPath = path_1.default.join(basePath, '_sources');
        if (!fs.existsSync(sourceDirPath)) {
            fs.mkdirSync(sourceDirPath, { recursive: true });
        }
        const idPrefix = typeof args.idPrefix !== 'undefined' ? args.idPrefix : 'icon_';
        logger_1.default.info(`symbols split svg ${basePath} ...`);
        const targetSvgFile = path_1.default.join(basePath, 'index.svg');
        const svgContent = fs
            .readFileSync(targetSvgFile, { encoding: 'utf8', flag: 'r' })
            .toString();
        const symbols = svgContent.match(equal_1.regPattern.symbol);
        if (symbols !== null) {
            symbols.forEach(symbol => {
                const idRes = new RegExp(equal_1.regPattern.htmlAttrId).exec(symbol);
                if (idRes && idRes.length > 1) {
                    const targetSvgFile = path_1.default.join(sourceDirPath, `${idRes[1].replace(idPrefix, '')}.svg`);
                    const pathContent = (0, string_1.removeStartEnd)(symbol, '<symbol\\b[^>]*?(?:viewBox=\\"(\\b[^"]*)\\")?>', '<\\/symbol>');
                    // ======== write type file start ========
                    fs.writeFileSync(targetSvgFile, `<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 1024 1024" width="200" height="200">${pathContent.trim().replace('    ', '')}</svg>`);
                    // ======== write type file end ========
                }
            });
        }
        logger_1.default.success(`Split to ${sourceDirPath}`);
        // By OSX Notice
        (0, utils_1.bash)(`osascript -e 'display notification "${basePath} done" with title "publish done"'`);
    });
}
exports.default = run;
module.exports = run;
//# sourceMappingURL=index.js.map