#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const yargs_1 = __importDefault(require("yargs/yargs"));
const helpers_1 = require("yargs/helpers");
module.exports = function bearScript() {
    return __awaiter(this, void 0, void 0, function* () {
        (0, yargs_1.default)((0, helpers_1.hideBin)(process.argv))
            .command('build-symbols [path] [idPrefix]', 'svg merge symbols', (yargs) => {
            return yargs
                .positional('path', {
                describe: 'svg source path (ex: ./public/icon -> ./public/icon/_sources)',
                default: './public/static/plugins/iconsvg',
            })
                .positional('idPrefix', {
                describe: 'id prefix name (ex: icon_ -> icon_arrow_right)',
                default: 'icon_',
            });
        }, (argv) => {
            const run = require('./build-symbols');
            run(argv);
        })
            .command('decode-iconfont [path]', 'svg merge symbols', (yargs) => {
            return yargs
                .positional('path', {
                describe: 'iconfont path (ex: ./public/iconfont -> ./public/iconfont/iconfont.js)',
                default: './public/static/plugins/iconfont',
            })
                .positional('idPrefix', {
                describe: 'id prefix name (ex: icon_ -> icon_arrow_right)',
                default: 'icon_',
            });
        }, (argv) => {
            const run = require('./decode-iconfont');
            run(argv);
        })
            .command('decode-symbols [path]', 'symbols split svg list', (yargs) => {
            return yargs
                .positional('path', {
                describe: 'symbols path (ex: ./public/icon -> ./public/icon/index.svg)',
                default: './public/static/plugins/iconsvg',
            })
                .positional('idPrefix', {
                describe: 'id prefix name (ex: icon_ -> icon_arrow_right)',
                default: 'icon_',
            });
        }, (argv) => {
            const run = require('./decode-symbols');
            run(argv);
        })
            .demandCommand(1)
            .parse();
    });
};
//# sourceMappingURL=index.js.map